using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using Infrastructure.Base;
using Shared;

namespace Infrastructure.Entities;

public class Session : EntityBase
{
    [Required]
    public string Name { get; set; }
    public string Description { get; set; }
    public EDay Day { get; set; }
    public ETarget Target { get; set; }

    // Clé étrangère explicite vers TrainingProgram
    [Required]
    public string TrainingProgramId { get; set; }
    public TrainingProgram TrainingProgram { get; set; }

    public virtual ICollection<Exercice> Exercices { get; set; } = new Collection<Exercice>();
}