using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using Infrastructure.Base;
using Shared;

namespace Infrastructure.Entities;

public class TrainingProgram : EntityBase
{
    [Required]
    public string Name { get; set; }

    public ELang Lang { get; set; }
    
    public int WeekDuration { get; set; }
    public string OwnerId { get; set; }
    public EGoal Goal { get; set; }
    
    public EDifficulty Difficulty { get; set; }
    
    public virtual ICollection<Session> Sessions { get; set; } = new Collection<Session>();
}