using AutoMapper;
using Infrastructure.Entities;
using Server.Dto.Request;
using Server.Dto.Response;

namespace Server.Mappers
{
    public class ExerciceProfile : Profile
    {
        public ExerciceProfile()
        {
            CreateMap<Exercice, ResponseExerciceDto>()
                .ForMember(dest => dest.TemplateName, opt => opt.MapFrom(src => src.Template.Name))
                .ForMember(dest => dest.TemplateInstructions, opt => opt.MapFrom(src => src.Template.Instructions))
                .ForMember(dest => dest.TemplateImageId, opt => opt.MapFrom(src => src.Template.ImageId))
                .ForMember(dest => dest.TemplateVideoId, opt => opt.MapFrom(src => src.Template.VideoId));
            
            CreateMap<RequestExerciceDto, Exercice>();
        }
    }
}