using AutoMapper;
using Infrastructure.Entities;
using Server.Dto.Request;
using Server.Dto.Response;

namespace Server.Mappers
{
    public class ExerciceTemplateProfile : Profile
    {
        public ExerciceTemplateProfile()
        {
            // Mapping de l'entité vers le DTO de réponse
            CreateMap<Exercice_template, ResponseTemplateExerciceDto>()
                .ForMember(dest => dest.Id, opt => opt.MapFrom(src => src.Id))
                .ForMember(dest => dest.Name, opt => opt.MapFrom(src => src.Name))
                .ForMember(dest => dest.Equipment, opt => opt.MapFrom(src => src.Equipment))
                .ForMember(dest => dest.Instructions, opt => opt.MapFrom(src => src.Instructions))
                .ForMember(dest => dest.Duration, opt => opt.MapFrom(src => src.Duration))
                .ForMember(dest => dest.ImageId, opt => opt.MapFrom(src => src.ImageId))
                .ForMember(dest => dest.VideoId, opt => opt.MapFrom(src => src.VideoId));

            // Mapping du DTO de requête vers l'entité
            CreateMap<RequestTemplateExerciceDto, Exercice_template>()
                // Comme la propriété Name n'est pas fournie dans le DTO, on l'ignore ici
                .ForMember(dest => dest.Name, opt => opt.Ignore())
                .ForMember(dest => dest.Equipment, opt => opt.MapFrom(src => src.Equipment))
                .ForMember(dest => dest.Instructions, opt => opt.MapFrom(src => src.Instructions))
                .ForMember(dest => dest.Duration, opt => opt.MapFrom(src => src.Duration))
                .ForMember(dest => dest.ImageId, opt => opt.MapFrom(src => src.ImageId))
                .ForMember(dest => dest.VideoId, opt => opt.MapFrom(src => src.VideoId));
        }
    }
}