using AutoMapper;
using Infrastructure.Entities;
using Server.Dto.Request;
using Server.Dto.Response;

namespace Server.Mappers
{
    public class TrainingProgramProfile : Profile
    {
        public TrainingProgramProfile()
        {
            CreateMap<TrainingProgram, ResponseTrainingProgramDto>()
                .ForMember(dest => dest.Id, opt => opt.MapFrom(src => src.Id))
                .ForMember(dest => dest.Name, opt => opt.MapFrom(src => src.Name))
                .ForMember(dest => dest.Lang, opt => opt.MapFrom(src => src.Lang))
                .ForMember(dest => dest.OwnerId, opt => opt.MapFrom(src => src.OwnerId))
                .ForMember(dest => dest.WeekDuration, opt => opt.MapFrom(src => src.WeekDuration))
                .ForMember(dest => dest.EGoal, opt => opt.MapFrom(src => src.Goal))
                .ForMember(dest => dest.EDifficulty, opt => opt.MapFrom(src => src.Difficulty))
                .ForMember(dest => dest.Sessions, opt => opt.MapFrom(src => src.Sessions));

            CreateMap<RequestTrainingProgramDto, TrainingProgram>()
                .ForMember(dest => dest.Name, opt => opt.MapFrom(src => src.Name))
                .ForMember(dest => dest.Lang, opt => opt.MapFrom(src => src.Lang))
                .ForMember(dest => dest.OwnerId, opt => opt.MapFrom(src => src.OwnerId))
                .ForMember(dest => dest.WeekDuration, opt => opt.MapFrom(src => src.WeekDuration.HasValue ? src.WeekDuration.Value : 0))
                .ForMember(dest => dest.Goal, opt => opt.MapFrom(src => src.EGoal))
                .ForMember(dest => dest.Difficulty, opt => opt.MapFrom(src => src.EDifficulty))
                .ForMember(dest => dest.Sessions, opt => opt.MapFrom(src => src.Sessions));
        }
    }
}